#!/usr/bin/env coffee

__cli__ = require("commander")
__async__ = require("async")
__cp__ = require("child_process")
__path__ = require("path")
__colors__ = require("colors")

__cli__
	.version("0.1.1")
	.usage("-s [-n -p -f -c -i] | -t")
	.option("-t, --test", "Unit test project using Mocha")
	.option("-s, --start", "Start server using node (default to development mode)")
	.option("-p, --production", "Start server in deployment mode. (option of --start)")
	.option("-n, --nodemon", "Start server with nodemon instead.  (option of --start)")
	.option("-f, --forever", "Start server with forever instead.  (option of --start)")
	.option("-c, --cluster", "Start server using cluster.js instead of app.js.  (option of --start)")
	.option("-i, --instance", "Start server using instance.js instead of app.js.  (option of --start)")
	.parse(process.argv)

__cli__.help() if (!__cli__.start and !__cli__.test)

if __cli__.start
	__cli__.help() if (__cli__.test)

	__async__.series [ (callback) ->
		install = __cp__.spawn("npm", ['install'], {stdio: 'inherit'})
		install.on('exit', () ->
			callback()
		)
	, (callback) ->
		appToLaunch = if __cli__.forever then 'forever' else if __cli__.nodemon then 'nodemon' else 'node'
		fileToLaunch = if __cli__.cluster then 'cluster.js' else if __cli__.instance then 'instance.js' else 'app.js'

		process.env.NODE_ENV = if __cli__.production then "production" else "development"
		server = __cp__.spawn(appToLaunch, [fileToLaunch], {stdio: 'inherit'})
		server.on('exit', () ->
			process.exit(0)
		)
	]
else if __cli__.test
	test = __cp__.spawn('mocha', ['--recursive', 'tests', '-R', 'nyan'], {stdio: 'inherit'})
	test.on('exit', () ->
		process.exit(0)
	)
else __cli__.help()